]> git.proxmox.com Git - mirror_ubuntu-artful-kernel.git/blob - scripts/link-vmlinux.sh
Merge tag 'nfs-for-3.18-2' of git://git.linux-nfs.org/projects/trondmy/linux-nfs
[mirror_ubuntu-artful-kernel.git] / scripts / link-vmlinux.sh
1 #!/bin/sh
2 #
3 # link vmlinux
4 #
5 # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
6 # $(KBUILD_VMLINUX_MAIN). Most are built-in.o files from top-level directories
7 # in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
8 # Ordering when linking is important, and $(KBUILD_VMLINUX_INIT) must be first.
9 #
10 # vmlinux
11 # ^
12 # |
13 # +-< $(KBUILD_VMLINUX_INIT)
14 # | +--< init/version.o + more
15 # |
16 # +--< $(KBUILD_VMLINUX_MAIN)
17 # | +--< drivers/built-in.o mm/built-in.o + more
18 # |
19 # +-< ${kallsymso} (see description in KALLSYMS section)
20 #
21 # vmlinux version (uname -v) cannot be updated during normal
22 # descending-into-subdirs phase since we do not yet know if we need to
23 # update vmlinux.
24 # Therefore this step is delayed until just before final link of vmlinux.
25 #
26 # System.map is generated to document addresses of all kernel symbols
27
28 # Error out on error
29 set -e
30
31 # Nice output in kbuild format
32 # Will be supressed by "make -s"
33 info()
34 {
35 if [ "${quiet}" != "silent_" ]; then
36 printf " %-7s %s\n" ${1} ${2}
37 fi
38 }
39
40 # Link of vmlinux.o used for section mismatch analysis
41 # ${1} output file
42 modpost_link()
43 {
44 ${LD} ${LDFLAGS} -r -o ${1} ${KBUILD_VMLINUX_INIT} \
45 --start-group ${KBUILD_VMLINUX_MAIN} --end-group
46 }
47
48 # Link of vmlinux
49 # ${1} - optional extra .o files
50 # ${2} - output file
51 vmlinux_link()
52 {
53 local lds="${objtree}/${KBUILD_LDS}"
54
55 if [ "${SRCARCH}" != "um" ]; then
56 ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
57 -T ${lds} ${KBUILD_VMLINUX_INIT} \
58 --start-group ${KBUILD_VMLINUX_MAIN} --end-group ${1}
59 else
60 ${CC} ${CFLAGS_vmlinux} -o ${2} \
61 -Wl,-T,${lds} ${KBUILD_VMLINUX_INIT} \
62 -Wl,--start-group \
63 ${KBUILD_VMLINUX_MAIN} \
64 -Wl,--end-group \
65 -lutil ${1}
66 rm -f linux
67 fi
68 }
69
70
71 # Create ${2} .o file with all symbols from the ${1} object file
72 kallsyms()
73 {
74 info KSYM ${2}
75 local kallsymopt;
76
77 if [ -n "${CONFIG_HAVE_UNDERSCORE_SYMBOL_PREFIX}" ]; then
78 kallsymopt="${kallsymopt} --symbol-prefix=_"
79 fi
80
81 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
82 kallsymopt="${kallsymopt} --all-symbols"
83 fi
84
85 if [ -n "${CONFIG_ARM}" ] && [ -n "${CONFIG_PAGE_OFFSET}" ]; then
86 kallsymopt="${kallsymopt} --page-offset=$CONFIG_PAGE_OFFSET"
87 fi
88
89 if [ -n "${CONFIG_X86_64}" ]; then
90 kallsymopt="${kallsymopt} --absolute-percpu"
91 fi
92
93 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
94 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
95
96 ${NM} -n ${1} | \
97 scripts/kallsyms ${kallsymopt} | \
98 ${CC} ${aflags} -c -o ${2} -x assembler-with-cpp -
99 }
100
101 # Create map file with all symbols from ${1}
102 # See mksymap for additional details
103 mksysmap()
104 {
105 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
106 }
107
108 sortextable()
109 {
110 ${objtree}/scripts/sortextable ${1}
111 }
112
113 # Delete output files in case of error
114 trap cleanup SIGHUP SIGINT SIGQUIT SIGTERM ERR
115 cleanup()
116 {
117 rm -f .old_version
118 rm -f .tmp_System.map
119 rm -f .tmp_kallsyms*
120 rm -f .tmp_version
121 rm -f .tmp_vmlinux*
122 rm -f System.map
123 rm -f vmlinux
124 rm -f vmlinux.o
125 }
126
127 #
128 #
129 # Use "make V=1" to debug this script
130 case "${KBUILD_VERBOSE}" in
131 *1*)
132 set -x
133 ;;
134 esac
135
136 if [ "$1" = "clean" ]; then
137 cleanup
138 exit 0
139 fi
140
141 # We need access to CONFIG_ symbols
142 case "${KCONFIG_CONFIG}" in
143 */*)
144 . "${KCONFIG_CONFIG}"
145 ;;
146 *)
147 # Force using a file from the current directory
148 . "./${KCONFIG_CONFIG}"
149 esac
150
151 #link vmlinux.o
152 info LD vmlinux.o
153 modpost_link vmlinux.o
154
155 # modpost vmlinux.o to check for section mismatches
156 ${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
157
158 # Update version
159 info GEN .version
160 if [ ! -r .version ]; then
161 rm -f .version;
162 echo 1 >.version;
163 else
164 mv .version .old_version;
165 expr 0$(cat .old_version) + 1 >.version;
166 fi;
167
168 # final build of init/
169 ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
170
171 kallsymso=""
172 kallsyms_vmlinux=""
173 if [ -n "${CONFIG_KALLSYMS}" ]; then
174
175 # kallsyms support
176 # Generate section listing all symbols and add it into vmlinux
177 # It's a three step process:
178 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
179 # but __kallsyms is empty.
180 # Running kallsyms on that gives us .tmp_kallsyms1.o with
181 # the right size
182 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
183 # the right size, but due to the added section, some
184 # addresses have shifted.
185 # From here, we generate a correct .tmp_kallsyms2.o
186 # 2a) We may use an extra pass as this has been necessary to
187 # woraround some alignment related bugs.
188 # KALLSYMS_EXTRA_PASS=1 is used to trigger this.
189 # 3) The correct ${kallsymso} is linked into the final vmlinux.
190 #
191 # a) Verify that the System.map from vmlinux matches the map from
192 # ${kallsymso}.
193
194 kallsymso=.tmp_kallsyms2.o
195 kallsyms_vmlinux=.tmp_vmlinux2
196
197 # step 1
198 vmlinux_link "" .tmp_vmlinux1
199 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
200
201 # step 2
202 vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
203 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
204
205 # step 2a
206 if [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
207 kallsymso=.tmp_kallsyms3.o
208 kallsyms_vmlinux=.tmp_vmlinux3
209
210 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
211
212 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
213 fi
214 fi
215
216 info LD vmlinux
217 vmlinux_link "${kallsymso}" vmlinux
218
219 if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
220 info SORTEX vmlinux
221 sortextable vmlinux
222 fi
223
224 info SYSMAP System.map
225 mksysmap vmlinux System.map
226
227 # step a (see comment above)
228 if [ -n "${CONFIG_KALLSYMS}" ]; then
229 mksysmap ${kallsyms_vmlinux} .tmp_System.map
230
231 if ! cmp -s System.map .tmp_System.map; then
232 echo >&2 Inconsistent kallsyms data
233 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
234 cleanup
235 exit 1
236 fi
237 fi
238
239 # We made a new kernel - delete old version file
240 rm -f .old_version